// 音を鳴らすときのおまじない
import ddf.minim.*;
Minim minim;
AudioSnippet ex;

// 砲台の角度
float angle = 45;
// 投射角度
float theta;
// 初速（固定で100となっている）
float v0 = 100;
// 当社投射されてからの時間
float t;
// ボールのx座標，y座標
float ballX, ballY;
// ターゲットのx座標，y座標．最初はx座標が500
float targetX = 500;
float targetY;
// ターゲットの上下方向の速度
float targetVY = 2.0;
// スコアを格納する変数
int score = 0;

void setup() {
  size( 600, 400 );
  strokeWeight( 5 );
  textSize( 30 );
  // 音を付与してみる
  minim = new Minim( this );
  ex = minim.loadSnippet( "data/exp.wav" );
}

void draw() {
  // 背景はとりあえず白色にしよう
  background( 255 );
  // ボールのx座標，y座標を計算する
  ballX = v0*t*cos(radians(theta));
  ballY = v0*t*sin(radians(theta))-0.5*9.8*t*t;
  // Y軸は上下逆なので，heightから引く
  ballY = height - ballY;

  // ターゲットを移動させる
  targetY += targetVY;
  // ターゲットが端に来たら折り返す（速度を逆転させる）
  if ( targetY < 0 ) { 
    targetY = 0; 
    targetVY = -targetVY;
  } else if ( targetY > height ) {
    targetY = height;
    targetVY = -targetVY;
  }

  // 砲台を描画する
  line( 0, height, 20*cos(radians(angle)), height-20*sin(radians(angle)) );  
  fill( 255, 0, 0 );
  // 砲台の角度を表示する
  fill( 0 ); 
  text( angle + " degrees", 30, 30 );

  // ターゲットを描画する
  fill( 255, 0, 0 );
  ellipse( targetX, targetY, 50, 50 );
  // ボールを描画する
  fill( 255 ); 
  ellipse( ballX, ballY, 30, 30 );
  
  // ターゲットとボールとの距離を計算し，それぞれの円の中心間距離が
  // それぞれの半径を足した距離より短ければ衝突している
  if ( dist( targetX, targetY, ballX, ballY ) <= 25+15 ) {
    // 衝突している場合は，別の座標にターゲットを移動させる
    targetX = random( 0, width );
    targetY = random( 0, height );
    // 爆発音を鳴らす
    ex.rewind();
    ex.play();
    // スコアを増やす
    score++;
  }

  // スコを表示する
  text( "score = " + score, 400, 30 );
  // tを増やす
  t = t + 0.1;
}

// キーボード入力があるときの処理を書く
void keyPressed() {
  if ( keyCode == UP ) {
    // UPボタンが押された時は角度を増やす
    angle ++;
  } else if ( keyCode == DOWN ) {
    // DOWNボタンが押された時は角度を減らす
    angle --;
  } else if ( keyCode == RIGHT ) {
    // RIGHTボタンが押された時はtを0にし，angleを投射角度にする
    t = 0;
    theta = angle;
  }
}

// 音楽関係の終了処理
void stop(){
  ex.close();
  minim.stop();
  super.stop();
}

