// 真ん中の部分をブロックの基本座標とする
int blockX = 200;
int blockY = 200;
// 相対位置を記録するための変数
int dx;
int dy;
// 選択しているかどうかの判定に利用する変数
int selected = 0;
// クリアしたかどうかを判定する変数
int clear = 0;

void setup() {
  size( 400, 600 );
  textSize( 60 );
}

void draw() {
  // とりあえず背景は白色にする
  background( 255 );
  // 線は描画しない
  noStroke();

  // クリアしている時としていない時で動作を変える
  if ( clear == 0 ) {
    // クリアしていない時は画面下部にブロックの塊を描画
    fill( 0, 0, 255 );
    rect( 0, height-60, 60, 60 );
    rect( 120, height-60, 600-120, 60 );
    rect( 180, height-120, 600-150, 60 );

    if ( selected == 1 ) {
      // 選択されていたら赤色にする
      fill( 255, 0, 0 );
    } else {
      // 選択されていなかったら黒色にする
      fill( 0 );
    }
    // ブロックをマウスカーソルの場所に応じて移動
    blockX = mouseX+dx;
    blockY = mouseY+dy;

    // ブロックの座標が指定の場所までくると
    // clearの変数を1にしてクリア状態にする
    // ちなみに，次のdrawの時に「Clear!!」と表示される
    if ( blockX == 90 && blockY == height-90 ) {
      clear = 1;
    }
  } else {
    // クリアした時は「Clear!!」と描画
    text( "Clear!!", 30, 300 );
  }
}

// ボタンが押されたときの動作を設定する
void mousePressed() {
  // 下のでっぱりの部分の判定
  if ( mouseX >= blockX-20 && mouseX <= blockX+20 && mouseY >= blockY-100 && mouseY <= blockY+100 ) {
    println( "selected" );
    selected = 1;
    dx = blockX-mouseX;
    dy = blockY-mouseY;
  } 
  // 上の横棒の部分の判定
  else if ( mouseX >= blockX-100 && mouseX <= blockX+100 && mouseY >= blockY-20 && mouseY <= blockY+20 ) {
    println( "selected" );
    selected = 1;
    dx = blockX-mouseX;
    dy = blockY-mouseY;
  }
}

void mouseReleased() {
  // マウスのボタンが離されたら問答無用でselectedを0にする
  selected = 0;
}

