// アンロックされたかどうかのフラグ
int unlock = 0;
// スワイプする○の座標を格納する変数
int cx, cy;
// 選択されているかどうかのフラグ
int selected = 0;
// ○の移動速度（戻る速度）
int vx = 0;

void setup() {
  size( 300, 600 );
  strokeWeight( 5 );
  textSize( 36 );
  // cx, cyに値をいれて○を左端に配置
  cx  = 50;
  cy = 550;
}

void draw() {
  background( 200 );
  if ( unlock == 1 ) {
    // アンロックされたら（unlock==1なら）ウェルカム！と表示する
    background( 0, 0, 255 );
    text( "Hello, welcome!", 10, 300 );
  } else {
    // アンロックされていなかったら（unlock==0なら）ロック画面を表示する
    text( "Please swipe!", 10, 300 );
    // ガイドとなる線を描画する
    line( 50, 550, 250, 550 );
    // 選択されているときは○の位置をマウスのx座標に
    if ( selected == 1 ) {
      cx = mouseX;
    } else {
      // 選択されていなかったらとりあえず指定の速度で動かす
      cx += vx;
    }
    // ただし，両端に来ていたら座標を補正する
    if ( cx < 50 ) { 
      cx = 50;
    } else if ( cx > 250 ) { 
      cx = 250;
    }
    // ○を描画する
    ellipse( cx, cy, 30, 30 );
  }
}

void mousePressed() {
  // 丸の中でボタンが押されたら選択状態にする（selected=1）
  if ( dist( cx, cy, mouseX, mouseY ) <= 15 ) {
    selected = 1;
  }
}

void mouseReleased() {
  // マウスのボタンが離されたら選択解除する
  selected = 0;
  // マウスのボタンが離された場所が右端なら
  // アンロックする（unlock=1とする）
  if ( cx == 250 ) {
    unlock = 1;
  } else {
    // 右端でなかったら左側に速度5で動かすための変数をセットする
    vx = -5;
  }
}

